FULL_EMPTY = "E0000"  # 1 key blank space
HALF_EMPTY = "E00"  # 1 half key blank space
SMALL_EMPTY = "E0"  # very small blank space
GHOST = 'GHOST'
INV_GHOST = 'INVISIBLE GHOST'

layouts = {
    'reference': [
        [
            GHOST,
            "esc",
            GHOST,
            "F1",
            "F2",
            "F3",
            "F4",
            "F5",
            "F6",
            "F7",
            "F8",
            "F9",
            "F10",
            "F11",
            "F12",
            "prt\nscr",
            "scr\nlk",
            "pause",
            GHOST,
            GHOST,
            'logo',
            'JP1'
        ],
        [
            'M1',
            "`",
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "0",
            "-",
            "=",
            "backspace",
            "ins",
            "home",
            "pg\nup",
            "num\nlk",
            "/",
            "*",
            "-",
        ],
        [
            'M2',
            "tab",
            "q",
            "w",
            "e",
            "r",
            "t",
            "y",
            "u",
            "i",
            "o",
            "p",
            "[",
            "]",
            "\\",
            "del",
            "end",
            "pg\ndwn",
            "7",
            "8",
            "9",
            "plus"
        ],
        [
            'M3',
            "capslk",
            "a",
            "s",
            "d",
            "f",
            "g",
            "h",
            "j",
            "k",
            "l",
            ";",
            "\'",
            "§",
            "ret",
            GHOST,
            GHOST,
            GHOST,
            "4",
            "5",
            "6",
            GHOST,
        ],
        [
            'M4',
            "lshift",
            "<",
            "z",
            "x",
            "c",
            "v",
            "b",
            "n",
            "m",
            ",",
            ".",
            "/",
            "JP2",
            "rshift",
            GHOST,
            "↑",
            GHOST,
            "1",
            "2",
            "3",
            "enter",
        ],
        [
            'M5',
            "lctrl",
            "super",
            "lalt",
            "JP3",
            GHOST,
            GHOST,
            "spacebar",
            GHOST,
            "JP4",
            "JP5",
            "ralt",
            "fn",
            "menu",
            "rctrl",
            "←",
            "↓",
            "→",
            GHOST,
            "0",
            "del",
            GHOST,
        ]
    ],
    'iso_it': [
        [
            "esc",
            "F1",
            "F2",
            "F3",
            "F4",
            "F5",
            "F6",
            "F7",
            "F8",
            "F9",
            "F10",
            "F11",
            "F12",
            "prt\nscr",
            "scr\nlk",
            "pause",
        ],
        [
            "\\",
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "0",
            "\'",
            "ì",
            "backspace",
            SMALL_EMPTY,
            "ins",
            "home",
            "pg\nup",
            SMALL_EMPTY,
            "num\nlk",
            "/",
            "*",
            "-",
        ],
        [
            "tab",
            "q",
            "w",
            "e",
            "r",
            "t",
            "y",
            "u",
            "i",
            "o",
            "p",
            "è",
            "+",
            "entertop",
            SMALL_EMPTY,
            "del",
            "end",
            "pg\ndwn",
            SMALL_EMPTY,
            "7",
            "8",
            "9",
            "plustop"
        ],
        [
            "capslk",
            "a",
            "s",
            "d",
            "f",
            "g",
            "h",
            "j",
            "k",
            "l",
            "ò",
            "à",
            "ù",
            "enterbottom",
            FULL_EMPTY,
            HALF_EMPTY,
            HALF_EMPTY,
            HALF_EMPTY,
            HALF_EMPTY,
            "4",
            "5",
            "6",
            "plusbottom",
        ],
        [
            "lshift",
            "<",
            "z",
            "x",
            "c",
            "v",
            "b",
            "n",
            "m",
            ",",
            ".",
            "-",
            "rshift",
            SMALL_EMPTY,
            FULL_EMPTY,
            "↑",
            FULL_EMPTY,
            SMALL_EMPTY,
            "1",
            "2",
            "3",
            "numentertop",
        ],
        [
            "lctrl",
            "⌘",
            "alt",
            "spacebar",
            "altgr",
            "fn",
            "≣",
            "rctrl",
            SMALL_EMPTY,
            "←",
            "↓",
            "→",
            SMALL_EMPTY,
            "num0",
            ".",
            "numenterbottom",
        ]
    ],
    'ansi_us': [
        [
            GHOST,
            "esc",
            GHOST,
            "F1",
            "F2",
            "F3",
            "F4",
            "F5",
            "F6",
            "F7",
            "F8",
            "F9",
            "F10",
            "F11",
            "F12",
            "prt\nscr",
            "scr\nlk",
            "pause",
            GHOST,
            GHOST,
            'logo',
            GHOST,
        ],
        [
            'M1',
            "`",
            "1",
            "2",
            "3",
            "4",
            "5",
            "6",
            "7",
            "8",
            "9",
            "0",
            "-",
            "=",
            "bck\nspc",
            "ins",
            "home",
            "pg\nup",
            "num\nlk",
            "/",
            "*",
            "-",
        ],
        [
            'M2',
            "tab",
            "q",
            "w",
            "e",
            "r",
            "t",
            "y",
            "u",
            "i",
            "o",
            "p",
            "[",
            "]",
            "\\",
            "del",
            "end",
            "pg\ndwn",
            "7",
            "8",
            "9",
            "plus"
        ],
        [
            'M3',
            "capslk",
            "a",
            "s",
            "d",
            "f",
            "g",
            "h",
            "j",
            "k",
            "l",
            ";",
            "\'",
            INV_GHOST,
            "ret",
            GHOST,
            GHOST,
            GHOST,
            "4",
            "5",
            "6",
            GHOST,
        ],
        [
            'M4',
            "lshift",
            INV_GHOST,
            "z",
            "x",
            "c",
            "v",
            "b",
            "n",
            "m",
            ",",
            ".",
            "/",
            INV_GHOST,
            "rshift",
            GHOST,
            "↑",
            GHOST,
            "1",
            "2",
            "3",
            "enter",
        ],
        [
            'M5',
            "lctrl",
            "◆",
            "lalt",
            INV_GHOST,
            INV_GHOST,
            INV_GHOST,
            "spacebar",
            INV_GHOST,
            INV_GHOST,
            INV_GHOST,
            "ralt",
            "fn",
            "menu",
            "rctrl",
            "←",
            "↓",
            "→",
            GHOST,
            "0",
            "del",
            GHOST,
        ]
    ]
}
